#ifndef	__HEADER_H__
#define __HEADER_H__

#include <sys/types.h>
#include <strfunc.h>

class
CHeadLine {
private:
	char *fieldname;	/* Spans till the end of header line */
	char *fieldbody;	/* Pointer to the value, after whitespaces */
	slist *params;
	slist *values;
	size_t fullsize;	/* strlen(fieldname) */
	int   free2destroy;	/* We have data allocated and must destroy it */

public:
	CHeadLine(int Take = 0);
	~CHeadLine();

	int Set(const char *line);
	char *Value();
	char *String();
	char *Param(char *toFind = NULL);
	size_t size();

};

class
CHeader {

private:
	int nHeadLines;	// Quantity of HeadLines
	int sHeadLines;	// Size of headLines array
	class CHeadLine **headLines;

	char *reconstrHeader;	/* Re-constructed header */

public:
	CHeader();
	~CHeader();

	int AddHeadLine(const char *headerLine, int Take = 0);
	char *HeadLineValue(char *fieldName);
	char *HeadLineParam(char *fieldName, char *optionName = NULL);

	char *Save(size_t *size = NULL);

private:
	size_t size();
	void extendHeadLines();
};


#endif
