#ifndef	__MAIL_H__
#define __MAIL_H__

#include <sys/types.h>
#include "mbox.h"
#include "header.h"

class CMail {
private:
	char *bodyp;

	CHeader header;

	int	bodysize_;
	int	filesize_average_;
	int msgid_;
	int partid_;
	int msgnum_;
	char *fname_;
	time_t date_;

	unsigned int is_flags_;
/*
** 1: filled by SetMail()
** 2: filled by SetBody()
** 3: filled by AddPart().
*/
	int filled_;
	int freebodyatdestroy;
	char *boundary_;

	int pcount_, psize_;
	CMail **parts_;

public:
	CMail();
	~CMail();

	/* User-defined flags for the message */
	unsigned int Flags;

	char	*SetMail(char *headPointer, int msgnum=0, int msgid=-1, int partid=0);
	int		SetBody(char *body, int FatD = 0);
	int		AddPart(CMail *m);

	int		AddHeadLine(const char *field, const char *optParam = NULL);

	char	*HeadLineValue(char *fieldName);
	char	*HeadLineParam(char *fieldName, char *optionName = NULL);

	time_t	Date();

	char *Save();
	int Save(int fd);
	int Save(FILE *fd);
	int	BodySize();

	char	*filename();
	void	*file(size_t *size=NULL);
	size_t	filesize_average();

	int	IsMime();
	int	IsMultipart();

	int	MsgId();
	int	MsgNum();
	int PartId();

	CMail **parts();

	char *ConstructMIMEBoundary();

	friend class CMailBox;

private:

	// 0 means - all ok, non zero is 'try again'
	int i_CheckMIMEBoundary(const char *boundary);
};


#endif
