#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <strfunc.h>
#include <sys/types.h>
#include <sys/time.h>
#include <ctype.h>
#include <lgba.h>

#include <common.h>
#include <mbox.h>
#include <mail.h>
#include <lpgp.h>

inline char *cf(char *a) {
	register char *z=cfgget(a);
	static char quote[]={ '\0' };
	return z?z:quote;
};

int main() {
	char *p;

	printf("Expires: %s\n",
		timetostr(0, TFMT_RFC822 | TFMT_OLD822GMT));

	init();

	printf("Content-type: text/html");
	if((p=cfgget("charset")))
		printf("; charset=%s", p);
	printf("\n\n%s", cf("start"));

	if(param("keygen") && pgpinit("")) {
		slist *sl=param2("pgppassphrase", 0);
		if(sl && sl->count > 1)
		for(int i=1; i<sl->count; i++)
			if(!eq(sl->list[i-1], sl->list[i])) {
				printf("%s", cf("pgp-passphrases-nomatch"));
				printf("%s", cf("pgp-keygen-failed"));
				printf("%s", cf("end"));
				return 0;
			};

		if(!Info->pgp_passphrase || strlen(Info->pgp_passphrase) < 3) {
			printf("%s", cf("pgp-keygen-failed"));
			printf("%s", cf("end"));
			return 0;
		};

		int keysize=1024;
		if((p=param("pgpkeysize"))) keysize = atoi(p);

		int keyalg=0;
		if((p=param("pgpkeyalg"))) keyalg = atoi(p);

		int expdays=365;
		if((p=param("pgpexpdays"))) expdays = atoi(p);
		if(expdays < 0) expdays = 0;

		if(pgpkeyinit(keyalg, keysize, expdays)) {
			if(pgpErrString)
				printf("%s", pgpErrString);
			printf("%s", cf("pgp-keygen-failed"));
			pgpcleanup();
			printf("%s", cf("end"));
			return 0;
		};
		pgpcleanup();
		printf("%s", cf("pgp-keygen-ok"));
		printf("%s", cf("end"));
		return 0;
	};

	char *pgpfilter=param("pgpfilter");
	if(!pgpfilter) pgpfilter="";

	if(pgpinit(pgpfilter)) {
		printf("%s", cf("pgp-generate-keys"));
		pgpcleanup();
		exit(2);
	};

	char *doit=param("do");
	if(!doit) {
		printf("%s", cf("pgp-keys-start"));
		pgpprintkeys(cf("pgp-keys-format"));
		printf("%s", cf("pgp-keys-end"));
		printf("%s", cf("pgp-keys-import"));
		printf("%s", cf("end"));
		pgpcleanup();
		return 0;
	};

	if(ecq(doit, "export")) {
		printf("</CENTER><PRE>%s</PRE><CENTER>", pgpexportkeys(0));
		printf("%s", cf("end"));
		pgpcleanup();
		return 0;
	};

	if(ecq(doit, "import")) {
		char *imp=param("pgpimport");
		printf("<PRE>");
		if(!imp || pgpimportkeys(imp)) {
			printf("</PRE>%s", replace(cf("pgp-import-failed"),
				(char *)"%e", pgpErrString?pgpErrString:(char *)"unknown error"));
		} else
			printf("</PRE>%s", cf("pgp-import-ok"));
		printf("%s", cf("end"));
		pgpcleanup();
		return 0;
	};

	printf("%s", cf("end"));
	pgpcleanup();
	return 0;
};

