#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <strfunc.h>
#include <sys/types.h>
#include <sys/time.h>
#include <ctype.h>
#include <mbox.h>
#include <mail.h>
#include <lgba.h>
#include "main.h"

#ifdef PGP
#include <lpgp.h>
#else
#endif

int
findpart(CMail *mail, char *fname, int partid) {
//	FILE *f=fopen("/dev/console", "w");

	if(!fname)
		return -1;

/*
	if(mail->PartId() == 0)
		fprintf(f, "\n\n");

	printf("findpart(mail=[%p], fname=[%s], partid=[%d])\n",
		mail, fname, partid);
	printf("mail->PartId() = %d\n", mail->PartId());
*/

#ifdef PGP
	static int pgpinitialized = 0;

	if(!pgpinitialized && param("decrypt")) {
		if(pgpinit("")) {
			printf("Content-Type: text/html");
			if(cfgget("charset"))
				printf("; charset=%s\n\n", cfgget("charset"));
			else
				printf("\n\n");
			printf("%s", cf("start"));
			printf("%s", cf("pgp-init-failed"));
			if(pgpErrString)
				printf("<BR>[%s]", pgpErrString);
			printf("%s", cf("end"));
			return 0;
		}
		pgpinitialized = 1;
	}
#endif

	char *fn=NULL;

	if(!strncasecmp(fname, "cid:", sizeof("cid:")-1)) {
		if((fn=mail->HeadLineValue("Content-ID:"))) {
			if(*fn == '<') {
				fn=sf_strdup(fn+1);
				fn[strlen(fn)-1]='\0';
			} else {
				fn=sf_strdup(fn);
			}
			if(!strcasecmp(fname + 4, fn)) {
				free(fn);
				fn = mail->filename();
				if(!fn) fn="untitled";
				fname = fn;
			} else {
				free(fn);
				fn=NULL;
			}
		}
	}

	if(!fn)
		fn=mail->filename();

	if(!mail->IsMime()) {
		if(!fn && (partid == -1)) return -1;
		if(fn && strcmp(fn, fname)) return -1;
		if(partid !=-1 && (mail->PartId() != partid)) return -1;

#ifdef PGP
	if(pgpinitialized) {
	
		void *data=mail->file();
		size_t size=strlen((char *)data);

		if(!(data=pgpdecode(data, &size))) {
			if(cfgget("charset"))
				printf("; charset=%s\n\n", cfgget("charset"));
			else
				printf("\n\n");
			printf("%s", cf("start"));
			printf("%s", cf("pgp-decode-failed"));
			if(pgpErrString)
				printf("<BR>[%s]", pgpErrString);
			printf("%s", cf("end"));
			return 0;
		}
		printf("Content-Type: text/plain");
		if(cfgget("charset"))
			printf("; charset=%s\n\n", cfgget("charset"));
		else
			printf("\n\n");
		fflush(stdout);
		fwrite(data, size, 1, stdout);
		fclose(stdout);
		return 0;
	}
#endif

		printf("Content-type: text/plain\n\n%s", (char *)mail->file());
		fclose(stdout);
		return 0;
	}

#ifdef PGP
	if(pgpinitialized) {
		char *ct = mail->HeadLineParam("Content-Type:", NULL);
		if(!ct) goto pivo;
		if(strcasecmp(ct, "multipart/encrypted")) goto pivo;
		ct = mail->HeadLineParam("Content-Type:", "protocol");
		if(!ct) goto pivo;
		if(strcasecmp(ct, "application/pgp-encrypted") != 0) goto pivo;

		void *data = mail->Save();
		size_t size = strlen((char *)data);

		if(!(data=pgpdecode(data, &size))) {
			if(cfgget("charset"))
				printf("; charset=%s\n\n", cfgget("charset"));
			else
				printf("\n\n");
			printf("%s", cf("start"));
			printf("%s", cf("pgp-decode-failed"));
			if(pgpErrString)
				printf("<BR>[%s]", pgpErrString);
			printf("%s", cf("end"));
			return 0;
		}

		if(!strncasecmp((char *)data, "Content-Type:", (13>size)?size:13)) {
			CMail *newmail = new CMail();
			newmail->SetMail((char *)data, mail->MsgNum(),
				mail->MsgId(), mail->PartId());
			newmail->AddHeadLine("MIME-Version: 1.0");
			mail = newmail;
			return findpart(mail, fname, partid);
		} else {
			CMail *newmail = new CMail();
			newmail->AddHeadLine("MIME-Version: 1.0");
			newmail->AddHeadLine("Content-Type:",
				mail->HeadLineParam("Content-Type:"));
			newmail->SetBody((char *)data, 1);
			mail = newmail;
		}
	}

pivo:

#endif

	if(!mail->IsMultipart()) {
		if(!fn && (partid == -1)) return -1;
		if(fn && strcmp(fn, fname)) return -1;
		if(partid !=-1 && (mail->PartId() != partid)) return -1;

		size_t size;
		void *data;
		data=mail->file(&size);

		char *ct = "application/octet-stream";
		if(!param("save")) {
			ct=mail->HeadLineParam("Content-Type:");
			if(ct) {
				char *p = (char *)alloca(strlen(ct)+1);
				strcpy(p, ct);
				ct = p;
				if((p = strchr(ct, ';'))) *p = '\0';
				if((p = strchr(ct, '\r'))) *p = '\0';
				if((p = strchr(ct, '\n'))) *p = '\0';
			} else {
				ct="text/plain";
			}
		}

		printf("Content-Length: %d\n", size);
		printf("Content-Type: %s\n\n", ct);
		fflush(stdout);
		fwrite(data, size, 1, stdout);
		fclose(stdout);
		return 0;
	}

	CMail **mails=mail->parts();
	if(!mails) {
		if(fn && strcmp(fn, fname)) return -1;
		if(partid !=-1 && (mail->PartId() != partid)) return -1;
		printf("Content-Type: text/plain\n\n%s",
			html_quote((char *)mail->file()));
		return 0;
	}

	for(CMail **mls=mails; *mls; mls++)
		if(findpart(*mls, fname, partid) != -1)
			return 0;

	return -1;
}


