#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <strfunc.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/time.h>
#include <signal.h>
#include <ctype.h>
#include <paths.h>
#include <lgba.h>

#include <common.h>

FILE *
openmta() {
	pid_t child;
	int piperw[2];
	FILE *f;
	int devnull;
	int ret;

	if(pipe(piperw) == -1)
		return NULL;

	fflush(NULL);

	child = fork();
	if(child == -1)
		return NULL;

	if(child) {
		close(piperw[0]);

		f = fdopen(piperw[1], "w");
		if(f == NULL) {
			close(piperw[1]);
			kill(child, SIGTERM);
		}
		return f;
	}

	close(piperw[1]);

	devnull = open(_PATH_DEVNULL, O_WRONLY);
	ret = dup2(piperw[0], 0);	// stdin
	if(ret == -1)
		_exit(0);
	dup2(devnull, 1);	// stdout
	dup2(devnull, 2);	// stderr

	char *sm = cfgget("sendmail");
	if(!sm) sm="/usr/sbin/sendmail";
	slist *sl = sinit();

	sadd(sl, "sendmail");
	sadd(sl, "-it");
	if(Info->from) {
		sadd(sl, "-f");
		sadd(sl, Info->from);
		/* From should be security checked already */
	}
	execv(sm, sarray(sl, 0));

	_exit(0);
};

